#Convert RGB to Hex and HSV with a colour swatch

#This scripts creates dual outputs from Thonny - to screen and to the Pico as an HTML.
#If you do not see output on the Pico first time, in Thonny press STOP to reconnect the Pico to refresh the view and the html file will appear.
#In Thonny right mouse click on the file in the Pico and download this HTML via Thonny to the PC to view.
#Use windows explorer to open on the PC and the html file will appear in your browser.
#The Input Comment field is appended to the file name to keep track of testing results.

#Convert RGB to Hex
def rgb_to_hex(rgb):
    return '#%02x%02x%02x' % rgb

#HSV Conversion
def rgb_to_hsv(r, g, b):
    r, g, b = r/255.0, g/255.0, b/255.0
    mx = max(r, g, b)
    mn = min(r, g, b)
    df = mx-mn
    if mx == mn:
        h = 0
    elif mx == r:
        h = (60 * ((g-b)/df) + 360) % 360
    elif mx == g:
        h = (60 * ((b-r)/df) + 120) % 360
    elif mx == b:
        h = (60 * ((r-g)/df) + 240) % 360
    if mx == 0:
        s = 0
    else:
        s = (df/mx)*100
    v = mx*100
    return h, s, v

#Start of RGB input
print("Convert RGB values to Hex and HSV")
print("")
iComment = input("Enter Colour Comment: ")
print("")
iRed=input("Enter RED ie 0-255 : ")
iGrn=input("Enter GREEN ie 0-255 : ")
iBlu=input("Enter BLUE ie 0-255 : ")
print("")
r=int(iRed)
g=int(iGrn)
b=int(iBlu)

#Display to screen
print("Comment - ", iComment)
print("RGB("+str(r)+","+str(g)+","+str(b)+")   Hex " + rgb_to_hex((r, g, b)))
print("HSV")
print(rgb_to_hsv(int(r), int(g), int(b))) 
print("Output to Convert_RGB2HexHSVHTML_"+iComment+".html ")

#Output to HTML file on PICO
file = open("Convert_RGB2HexHSVHTML_"+iComment+".html ", "w")

file.write("<!DOCTYPE html><html><head><style> th, td {border: 1px solid black;border-radius: 10px;background-color: "+rgb_to_hex((r,g,b))+";height:200px;width:200px;text-align:center;font-size:30px}")
file.write("</style></head>")
file.write("<h2>PICO COLOUR RGB To HEX# and HSV</h2>")
file.write("<body><p><br>"+"Comment - "+ iComment + "<br><br>")
file.write("RGB("+ str(r) +","+ str(g) + "," + str(b)+")   Hex " + rgb_to_hex((r,g,b)) + "<br>")
file.write("<table><tr><td><b>"+iComment+"</b></td></tr></table></body></html></font></p>")
file.flush()
file.close()



